#include <stdlib.h>
#include <stdio.h>
#include <file.h>
#include <string.h>

char S[100];

#include "iniread.h"

/* str_trim  -- Removes preceding and following spaces, and
 *              non-ascii characters (255 char max)
 */
void str_trim(signed char * string)
{
/*
    signed char tmpstr[255];
    int i = 0, j;

    if (strcmp(string, "") == 0)   //null string -- nothing to do!
        return;

    //strcpy(tmpstr, string);

    // First process start of string
    while (string[i]<=32 && string[i] != 0) i++;
    j=strlen(string);
    while (string[j]<=32 && j > i) j--;
    string[j+1]=0;
    strcpy(tmpstr, string+i);
    strcpy(string, tmpstr);*/
}

/*
 * GetPrivateProfileInt -- Windows 3.x compatible
 *                         Reads an int from an .ini file.
 */
int GetPrivateProfileInt(char * Section, char* Entry, int defaultint, char * iniFilename)
{
    char str[160], str1[160];
    FILE * inifile;
    bool found=false, donesection=false;
    int retval=defaultint;

    strcpy(str1, "[");
    strcat(str1, Section);
    strcat(str1, "]\n");
    inifile=fopen(iniFilename, "rt");
    if (!inifile) return defaultint;
    fseek(inifile, 0, SEEK_SET);
    while (!feof(inifile) && !found)
    {
       fgets(str, 160, inifile);
       str_trim(str);
       if (stricmp(str, str1)==0)
           found=true;
    }
    if (!found)
    {
       fclose(inifile);
       return defaultint;
    }
    found=false;  //Ok.  Got the section, now to find the key.
    strcpy(str1, Entry);
    strcat(str1, "=");
    while (!feof(inifile) && !found && !donesection)
    {
       fgets(str, 160, inifile);
       str_trim(str);
       if (strnicmp(str, str1, strlen(str1))==0)
       {
           sscanf(str+strlen(str1),"%i",&retval);
           found=true;
       }
       else
       if (str[0]=='[') donesection=true;
    }
    if (!found)
    {
       fclose(inifile);
       return defaultint;
    }
    fclose(inifile);
    return retval;
}

/*
 * GetPrivateProfileString -- Windows 3.x compatible
 *                            Reads a string from an .ini file.
 */
int GetPrivateProfileString(char * Section, char* Entry, char * defaultstr, char * returnbuf, int size, char * iniFilename)
{
    char str[160], str1[160];
    FILE * inifile;
    bool found=false, donesection=false;
    //int retval=defaultint;

    strcpy(str1, "[");
    strcat(str1, Section);
    strcat(str1, "]\n");
    inifile=fopen(iniFilename, "rt");
    if (!inifile)
    {
       strcpy (returnbuf, defaultstr);
       return strlen(returnbuf);
    }
    fseek(inifile, 0, SEEK_SET);
    while (!feof(inifile) && !found)
    {
       fgets(str, 160, inifile);
       str_trim(str);
       if (stricmp(str, str1)==0)
           found=true;
    }
    if (!found)
    {
       fclose(inifile);
       strcpy (returnbuf, defaultstr);
       return strlen(returnbuf);
    }
    found=false;  //Ok.  Got the section, now to find the key.
    strcpy(str1, Entry);
    strcat(str1, "=");
    while (!feof(inifile) && !found && !donesection)
    {
       fgets(str, 160, inifile);
       str_trim(str);
       if (strnicmp(str, str1, strlen(str1))==0)
       {
           if ((strlen(str) - strlen(str1)) < size)
           {
               strncpy(returnbuf, str+strlen(str1), strlen(str) - strlen(str1)-1);
               returnbuf[strlen(str) - strlen(str1)]=0;
               found=true;
           }
           else
           {
               strncpy(returnbuf, str+strlen(str1), size-1);
               returnbuf[size - 1] = 0;
               found=true;
           }
       }
       if (str[0]=='[') donesection=true;
    }
    if (!found)
    {
       fclose(inifile);
       strcpy (returnbuf, defaultstr);
       return strlen(returnbuf);
    }
    fclose(inifile);
    str_trim(returnbuf);
    return strlen(returnbuf);
}

/*
 * WritePrivateProfileString -- Not finished/working
 *
BOOL WritePrivateProfileString(char * Section, char *Entry, char *String, char *iniFilename)
{
    FILE * inifile, inifilebak;
    char str[160], str1[160];
    char * filetmp;
    inifile = fopen(iniFilename, "rt");
    if (!inifile) return defaultint;
    fseek(inifile, 0, SEEK_SET);
    filetmp=(char*)calloc(filelength(fileno(inifile)),1);
    fread(filetmp, filelength(fileno(inifile)), 1, iniFilename);
    //tmpnam(tempfilename);
}
 */
